

#define MAXVARNAMELENGTH                15
#define MAXVARS                         512

typedef struct VARIABLE VARIABLE;
typedef struct EVALUATOR EVALUATOR;



#define EVALUATE_MISSING_VARIABLE       -1
#define EVALUATE_FAILED                 -2
#define EVALUATE_OK                      0
#define EVALUATE_ERROR                   1
#define EVALUATE_UNMATCHED_BRACKET       2
#define EVALUATE_ILLEGAL_VARIABLENAME    3
#define EVALUATE_TOO_MANY_VARIABLES      4
#define EVALUATE_VARIABLE_ALREADY_EXISTS 5
#define EVALUATE_UNSUPPORTED_COMPARISON  6
#define EVALUATE_DIVISION_BY_ZERO        7
#define EVALUATE_LOG_ARGUMENT            8
#define EVALUATE_RND_ARGUMENT            9
#define EVALUATE_SQR_ARGUMENT           10


#ifdef __cplusplus
extern "C" {
#endif

EVALUATOR *evaluator_init(void (* cb)(char *));
void evaluator_kill(EVALUATOR *eval);

S32 evaluate_expression(EVALUATOR *eval, char *expr, S32 *value);

S32 variable_exists(EVALUATOR *eval, char *var);
S32 create_variable(EVALUATOR *eval, char *var);
S32 destroy_variable(EVALUATOR *eval, char *var);
S32 set_variable_value(EVALUATOR *eval, char *var, S32 value);
S32 read_variable_value(EVALUATOR *eval, char *var, S32 *value);
#ifdef __cplusplus
}
#endif
