// asm: main.cpp
//


#include "main.h"

_LIT(KAsmDefaultFilePath, "C:\\");
_LIT(KAsmRequiredExtension, "S");
_LIT(KFontName, "Courier");
_LIT(KPathAndFile,"\\system\\apps\\asm\\cursor.mbm");
_LIT(KCDrive,"C:");
_LIT(KDDrive,"D:");


_LIT(KInfoOpeningFile, "Opening file...");
_LIT(KInfoSavingFile, "Saving file...");
_LIT(KInfoAssembling, "Assembling");
_LIT(KInfoSaveFirst, "You need to save the file before\nyou can assemble it...");
_LIT(KInfoSAppended, ".s appended to filename before saving");
_LIT(KInfoAsmFailed, "Assembling failed - this is most\nlikely due to lack of memory");
_LIT(KInfoAsmDoneErr, "Assembling failed");
_LIT(KInfoAsmDoneErrInfo, "%d errors or more were found. First error:\n%s line %d: %s");
_LIT(KInfoAsmDoneOK, "Assembling complete");
_LIT(KInfoAsmComplete, "Assembling completed without errors -\n output size is %d bytes");

//
// EXPORTed functions
//

EXPORT_C CApaApplication* NewApplication() {
  return new CAsmApplication;
}

GLDEF_C TInt E32Dll(TDllReason) {
  return KErrNone;
}

////////////////////////////////////////////////////////////////
//
// Application class, CAsmApplication
//
////////////////////////////////////////////////////////////////

TUid CAsmApplication::AppDllUid() const {
  return KUidAsm;
}


CApaDocument* CAsmApplication::CreateDocumentL() {
  // Construct the document using its NewL() function, rather
  // than using new(ELeave), because it requires two-phase
  // construction.
  return CAsmDocument::NewL(*this);
}


////////////////////////////////////////////////////////////////
//
// Document class, CAsmDocument
//
////////////////////////////////////////////////////////////////

// not much here...
CAsmDocument::CAsmDocument(CEikApplication& aApp) : CEikDocument(aApp) { }
void CAsmDocument::ConstructL() { }
CAsmDocument::~CAsmDocument() { }
void CAsmDocument::ResetModelL() { }
void CAsmDocument::NewDocumentL() { }
void CAsmDocument::RestoreL(const CStreamStore& aStore,const CStreamDictionary& aStreamDic) { }


CAsmDocument* CAsmDocument::NewL(CEikApplication& aApp) {

  CAsmDocument* self = new (ELeave) CAsmDocument(aApp);
  return self;
}


CEikAppUi* CAsmDocument::CreateAppUiL() {

  CEikAppUi *ui = new(ELeave) CAsmAppUi;
  return ui;
}

////////////////////////////////////////////////////////////////
//
// App UI class, CAsmAppUi
//
////////////////////////////////////////////////////////////////

void CAsmAppUi::ConstructL() {

  BaseConstructL();

  iToolBarVisible = ETrue;
  iToolBar->MakeVisible(iToolBarVisible);

  // construct appview
  iAppView = new (ELeave) CAsmAppView;
  iAppView->ConstructL(ClientRect(), (CAsmDocument *)iDocument, this);
  // create scrollbars
  iAppView->CreateComponentControlsL();
  // add window to stack
  AddToStackL(iAppView);

  ModelHasChanged();

  // set scrollbars to correct values
  iAppView->UpdateScrollBar(0, ETrue);

  iAppView->iActivated = ETrue;
  iAppView->UpdateParagraph();
}


CAsmAppUi::~CAsmAppUi() {
  delete iAppView;
}


void CAsmAppUi::HandleCommandL(TInt aCommand) {
// called when the user selects a menu or icon
// just figure what to do...
  switch (aCommand) {
  case EAsmCmdFileOpen:
    CmdFileOpenL();
    break;
  case EAsmCmdAssemble:
    iAppView->Assemble();
    break;
  case EAsmMenuOpenInclude:
    if (iAppView->IncludeFile().Compare(_L(""))) {
      TFileName file, incl;
      file = iAppView->FileName();
      incl = iAppView->IncludeFile();
      OpenFileFromSameDir(file, incl);
    }
    break;
  case EAsmMenuSaveAssembled:
    CmdFileSaveAssembledL();
    break;
  case EAsmCmdToggleToolBar:
    if (iToolBarVisible)
      iToolBarVisible = EFalse;
    else
      iToolBarVisible = ETrue;
    iToolBar->MakeVisible(iToolBarVisible);
    iAppView->RemoveScrollBarL();
    iAppView->CreateComponentControlsL();
    iAppView->ToggleToolBar();
    break;
  case EAsmCmdFileNew:
    CmdFileNewL();
    break;
  case EAsmCmdFileSave:
    iAppView->DoSaveFile();
    break;
  case EAsmCmdFileSaveAs:
    CmdFileSaveL();
    break;
  case EEikCmdExit:
    iAppView->DoSaveFile();
    Exit();
    break;
  case EAsmRecentFilesMenu:
    if (iAppView->iRecentFilesCount) {
      TPoint popup(iAppView->iScreenSizeX-KEikStdToolBarWidth,
                   iAppView->iScreenSizeY/2);
      LaunchPopupMenuL(R_ASM_RECENT_FILES_MENU, popup, EPopupTargetBottomRight);
    }
    break;
  case EEikCmdEditCut:
    iAppView->Cut();
    break;
  case EEikCmdEditCopy:
    iAppView->Copy();
    break;
  case EEikCmdEditPaste:
    iAppView->Paste();
    break;
  case EEikCmdZoomIn:
    iAppView->SetZoom(1, ETrue);
    break;
  case EEikCmdZoomOut:
    iAppView->SetZoom(-1, ETrue);
    break;
  case EAsmRecentFile1:
    iAppView->OpenRecentFile(0);
    break;
  case EAsmRecentFile2:
    iAppView->OpenRecentFile(1);
    break;
  case EAsmRecentFile3:
    iAppView->OpenRecentFile(2);
    break;
  case EAsmRecentFile4:
    iAppView->OpenRecentFile(3);
    break;
  case EAsmRecentFile5:
    iAppView->OpenRecentFile(4);
    break;
  case EAsmNextError:
    iAppView->GotoError(1);
    break;
  case EAsmPreviousError:
    iAppView->GotoError(-1);
    break;
  }
}


void CAsmAppUi::CmdFileSaveL() {
// user wants to save a file

  // Set an initial value for the folder to contain the new file
  // Pass this to the dialog box to display in the "Folder" field.
  TFileName filename;
  filename = KAsmDefaultFilePath;

  // Launch a standard EIKON dialog for the user to enter a filename
  CEikFileSaveAsDialog* dialog = new(ELeave) CEikFileSaveAsDialog(&filename);

  // If the dialog returns a filename, call OpenFileL() to open the file.
  if (dialog->ExecuteLD(R_EIK_DIALOG_FILE_SAVEAS))
    SaveFileL(filename);
}


void CAsmAppUi::CmdFileSaveAssembledL() {

  TFileName filename;
  filename = KAsmDefaultFilePath;
  if (iAppView->iSavedAsmFileName.Compare(_L("")))  filename = iAppView->iSavedAsmFileName;

  CEikFileSaveAsDialog* dialog = new(ELeave) CEikFileSaveAsDialog(&filename);
  if (dialog->ExecuteLD(R_EIK_DIALOG_FILE_SAVEAS))
      SaveFileAssembledL(filename);
}


void CAsmAppUi::CmdFileNewL() {
// user wants to create a new file

  // Set an initial value for the folder to contain the new file
  // Pass this to the dialog box to display in the "Folder" field.
  TFileName filename;
  filename = KAsmDefaultFilePath;

  // Launch a standard EIKON dialog for the user to enter a filename
  CEikFileSaveAsDialog* dialog = new(ELeave) CEikFileSaveAsDialog(&filename, NULL, R_EIK_TBUF_CREATE_NEW_FILE);

  // If the dialog returns a filename, call OpenFileL() to open the file.
  if (dialog->ExecuteLD(R_EIK_DIALOG_FILE_SAVEAS))  CreateFileL(filename);
}


void CAsmAppUi::CmdFileOpenL() {
// user wants to open a file

  // Set an initial value for the folder to contain the new file
  // Pass this to the dialog box to display in the "Folder" field.
  TFileName filename, extension;
  extension = KAsmRequiredExtension;
  SetInitialPathL(filename);

  // Launch a standard EIKON dialog for the user to enter a filename
  CEikFileOpenDialog* dialog = new(ELeave) CEikFileOpenDialog(&filename);
  dialog->SetRequiredExtension(&extension);

  // If the dialog returns a filename, call OpenFileL() to open the file.
  if (dialog->ExecuteLD(R_EIK_DIALOG_FILE_OPEN))  OpenFileL(filename);
}



void CAsmAppUi::CreateFileL(TFileName& aFileName) {
// create a new file
  iAppView->DoCreateNewFile(aFileName);
}


void CAsmAppUi::SaveFileAssembledL(TFileName& aFileName) {
  iAppView->DoSaveFileAssembled(aFileName);
}


void CAsmAppUi::SaveFileL(TFileName& aFileName) {
  iAppView->DoSaveFileAs(aFileName);
}


void CAsmAppUi::OpenFileFromSameDir(TFileName& aBase, TFileName& aIncl) {

  TFileName newfile;
  TParse parseincl;

  parseincl.Set(aIncl, NULL, NULL);
  if (parseincl.DrivePresent())
    newfile = aIncl;
  else {
    TParse parsebase;
    parsebase.Set(aBase, NULL, NULL);
    newfile = parsebase.DriveAndPath();
    newfile.Append(aIncl);
  }

  OpenFileL(newfile);
}


void CAsmAppUi::OpenFileL(TFileName& aFileName) {
// open a file

  // save the current file
  if (iAppView->DoSaveFile())              return;

  // Call the document function to open a file
  if (iAppView->DoOpenFile(aFileName))     return;

  // Update the UI to reflect the changes
  ModelHasChanged();
}


void CAsmAppUi::SetInitialPathL(TFileName& aFileName) {
// checks that the initial path exists, creating it if not
// if the path was read-only a default is used instead

  aFileName = iAppView->FileName();
  if (aFileName.Size() == 0) {
    aFileName = KAsmDefaultFilePath;
    ConeUtils::EnsurePathExistsL(aFileName);
    return;
  }
  TRAPD(ret, ConeUtils::EnsurePathExistsL(aFileName) );
  if (ret != KErrNone) {
    // if the path is eg read-only default to C:
    aFileName = KAsmDefaultFilePath;
    ConeUtils::EnsurePathExistsL(aFileName);
  }
}


void CAsmAppUi::ModelHasChanged() {
// handle all that is needed for switching file

  iAppView->DrawNow();

  CEikFileNameLabel* filenameLabel = STATIC_CAST(CEikFileNameLabel *,
                                     iToolBar->ControlById(EAsmLblFileName));
  filenameLabel->UpdateL();
  filenameLabel->DrawNow();
}


void CAsmAppUi::DynInitMenuPaneL(TInt aMenuId, CEikMenuPane* aMenuPane) {
  iAppView->DynInitMenuPaneL(aMenuId, aMenuPane);
}


////////////////////////////////////////////////////////////////
//
// Application view class, CAsmAppView
//
// this also handles everything that has to do with 'the model',
// that is, user input, redrawing load/save etc.
//
////////////////////////////////////////////////////////////////

void CAsmAppView::ConstructL(const TRect& aRect, CAsmDocument *aDoc, CAsmAppUi *aAppUi) {
// create a view of the current file/model

  iDocument = aDoc;
  iAppUi = aAppUi;

  iActivated = EFalse;
  iFileName = _L("");
  iSavedAsmFileName = _L("");
  iIncludeFile = _L("");
  iClipboard = NULL;
  iLibrary = _L("C:\\System\\Apps\\ASM\\asm.app");
  if (ConeUtils::FileExists(iLibrary))
    iLibrary = _L("C:\\System\\Apps\\ASM\\Libs");
  else
    iLibrary = _L("D:\\System\\Apps\\ASM\\Libs");

  iRecentFilesCount = 0;

  // output
  iAssembledOutput = NULL;
  iAsmErrorCount = 0;

  // create a window
  iGroup = iEikonEnv->RootWin();
  CreateWindowL(iGroup);

  iParaFormatLayer = CParaFormatLayer::NewL();
  iCharFormatLayer = CCharFormatLayer::NewL();
  iGlobalText = CGlobalText::NewL(iParaFormatLayer, iCharFormatLayer);

  iViewRect = aRect;
//  iViewRect.iTl.iX += 1;
//  iViewRect.iTl.iY += 1;
//  iViewRect.iBr.iY -= 1;
//  iViewRect.iBr.iX -= 1;

  // get graphics context and device
  CWindowGc& gc = SystemGc();
  CBitmapDevice *device = (CBitmapDevice *) (gc.Device());
  TSize s = device->SizeInPixels();
  iScreenSizeX = s.iWidth;
  iScreenSizeY = s.iHeight;
  // new layout - make it so wide that lines are never wrapped...
  iLayout = CTextLayout::NewL(iGlobalText, 20000);
  // construct layout, giving width of viewing rectangle text view
  iTextView = CTextView::NewL(iLayout, iViewRect, device, device,
                              &Window(), &iGroup, &iCoeEnv->WsSession());

  SetRectL(aRect);
  // open/display window
  ActivateL();

  // margin for line cursor
  iTextView->SetMarginWidths(0, 10);
  // load line cursor
  iBitmap = new(ELeave) CFbsBitmap();
  // !! EIKON service to do this in a soft-coded manner is forthcoming
  TBufC<40> pathandfile(KPathAndFile);
  TParse    bitmapfn;
  TBufC<2>  c_drive(KCDrive);
  TBufC<2>  d_drive(KDDrive);
  // first try c drive, if that fails, try d drive
  bitmapfn.Set(pathandfile,&c_drive,NULL);
  if (iBitmap->Load(bitmapfn.FullName())) {
    bitmapfn.Set(pathandfile,&d_drive,NULL);
    iBitmap->Load(bitmapfn.FullName());
  }

  iTextView->SetLineCursorBitmap(iBitmap);
  // make cursors visible...
  iTextView->SetCursorVisibilityL(TCursor::EFCursorVisible, TCursor::EFCursorFlashing|TCursor::EFCursorVisible);

  iLayout->ForceNoWrapping();

  iPreferredPosOnLine = -1;
  iPos = 0;
  iHeight = iScrolled = iScrollSpan = iThumbPosition = 0;
  iSelectionStart = iSelectionEnd = -1;
  iHasChanged = 0;
  iZoom = 0;
  SetZoom(1, EFalse);

  EnableDragEvents();
}


void CAsmAppView::ToggleToolBar() {

  // get current window size
  TRect r = Rect();
  // reduce/extend it
  if (iAppUi->iToolBarVisible)
    r.iBr.iX -= KEikStdToolBarWidth;
  else
    r.iBr.iX += KEikStdToolBarWidth;
  // set size and redraw
  SetRectL(r);
  ActivateL();

  // reduce rectangle further
  iViewRect = r;
//  iViewRect.iTl.iX += 1;
//  iViewRect.iTl.iY += 1;
//  iViewRect.iBr.iY -= 1;
//  iViewRect.iBr.iX -= 1;
  // set the textview rectangle
  iTextView->SetViewRect(iViewRect);

  // set scrollbar
  UpdateScrollBar(0, ETrue);
}


void CAsmAppView::SetZoom(TInt aChange, TBool aUpdateScrollBars) {

  TInt prevzoom;

  prevzoom = iZoom;
  iZoom += aChange;
  if (iZoom < 0)   iZoom = 0;
  if (iZoom > 3)   iZoom = 3;
  if (iZoom == prevzoom)   return;

  // increase the font size to 10 point - to make examples legible
  TCharFormat charFormat;
  TCharFormatMask charFormatMask;
  charFormat.iFontSpec.iTypeface.iName = KFontName;
  charFormat.iFontSpec.iFontStyle.SetStrokeWeight(EStrokeWeightNormal);
  switch (iZoom) {
  case 0:
    charFormat.iFontSpec.iHeight = 7*20;
    break;
  case 1:
    charFormat.iFontSpec.iHeight = 8*20;
    break;
  case 2:
    charFormat.iFontSpec.iHeight = 11*20;
    break;
  case 3:
    charFormat.iFontSpec.iHeight = 14*20;
    charFormat.iFontSpec.iFontStyle.SetStrokeWeight(EStrokeWeightBold);
    break;
  }
  charFormatMask.SetAttrib(EAttFontHeight);
  charFormatMask.SetAttrib(EAttFontTypeface);
  charFormatMask.SetAttrib(EAttFontStrokeWeight);

  CCharFormatLayer *charFormatLayer = CCharFormatLayer::NewL(charFormat, charFormatMask);
  iGlobalText->SetGlobalCharFormat(charFormatLayer);
  // replace the previous char format layer
  delete iCharFormatLayer;
  iCharFormatLayer = charFormatLayer;

  TInt err;
  TRAP(err,iTextView->FormatTextL());

  UpdateParagraph();

  if (aUpdateScrollBars) {
    UpdateScrollBar(0, ETrue);
    DrawNow();
  }
}


void CAsmAppView::HandleScrollEventL(CEikScrollBar* aScrollBar, TEikScrollEvent aEvent) {

  TEikScrollBarModel model = *(aScrollBar->Model());

  switch (aEvent) {
  case EEikScrollPageDown:
    model.iThumbPosition += model.iThumbSpan;
    break;
  case EEikScrollPageUp:
    model.iThumbPosition -= model.iThumbSpan;
    break;
  case EEikScrollDown:
    model.iThumbPosition += 20;
    break;
  case EEikScrollUp:
    model.iThumbPosition -= 20;
    break;
  case EEikScrollThumbDragVert:
    break;
  default:
    return;
    break;
  }
  model.CheckBounds();
  if (aEvent != EEikScrollThumbDragVert)
    aScrollBar->SetModelThumbPosition(model.iThumbPosition);

  TPoint screensize = iCoeEnv->ScreenDevice()->SizeInPixels().AsPoint();
  TInt sspan = iHeight;
  if (sspan < screensize.iY)   sspan = screensize.iY;
//  TInt scroll = (iScrollSpan - iThumbPosition) - model.iThumbPosition;
  TInt scroll = iThumbPosition - model.iThumbPosition;
  iTextView->ScrollDisplayPixelsL(scroll);
  iThumbPosition = model.iThumbPosition;
  iScrolled += scroll;
}


void CAsmAppView::DynInitMenuPaneL(TInt aMenuId, CEikMenuPane *aMenuPane) {
  // called to set up the menu before opening it
  switch (aMenuId) {
  case R_ASM_TOOLS_MENU:
    {
      // 'Open #include file' only available if cursor is on '#include' line
      TBool dim = ETrue;
      TBuf8<128> leadin;
      // check if the current line is an #include line
      iGlobalText->Extract(leadin, iParagraphStartPos, 9);
      if (leadin.Compare(_L("#include ")) == 0) {
        // get filename set to be included
        iGlobalText->Extract(leadin, iParagraphStartPos+9, 128);
        leadin.TrimLeft();
        TInt len = 0;
        while ((leadin[len] > ' ') && (len < leadin.Length()))  len++;
        if (len > 0) {
          leadin.SetLength(len);
          dim = EFalse;
          iIncludeFile = leadin;
        }
      }
      aMenuPane->SetItemDimmed(EAsmMenuOpenInclude, dim);

      // 'Assemble' is only available if filename is known
      dim = EFalse;
      if (iFileName.Compare(_L("")) == 0)   dim = ETrue;
      aMenuPane->SetItemDimmed(EAsmCmdAssemble, dim);

      // 'Next error' is only available if there are any errors
      dim = EFalse;
      if (iAsmErrorCount == 0)   dim = ETrue;
      aMenuPane->SetItemDimmed(EAsmNextError, dim);
      aMenuPane->SetItemDimmed(EAsmPreviousError, dim);
    }
    break;

  case R_ASM_VIEW_MENU:
    {
      if (iAppUi->iToolBarVisible)
        aMenuPane->SetItemButtonState(EAsmCmdToggleToolBar, EEikMenuItemSymbolOn);
    }
    break;

  case R_ASM_MORE_FILE_MENU:
    {
      // 'Save' is only available if a filename is set
      TBool dim = EFalse;
      if (iFileName.Compare(_L("")) == 0)  dim = ETrue;
      aMenuPane->SetItemDimmed(EAsmCmdFileSave, dim);
      // 'Save assembled' is only available if assembling completed
      dim = ETrue;
      if (iAssembledOutput)  dim = EFalse;
      aMenuPane->SetItemDimmed(EAsmMenuSaveAssembled, dim);
    }
    break;

  case R_ASM_RECENT_FILES_MENU:
    {
      if (iRecentFilesCount < 1)
        aMenuPane->DeleteMenuItem(EAsmRecentFile1);
      else
        aMenuPane->SetItemTextL(EAsmRecentFile1, iRecentFiles[0]);
      if (iRecentFilesCount < 2)
        aMenuPane->DeleteMenuItem(EAsmRecentFile2);
      else
        aMenuPane->SetItemTextL(EAsmRecentFile2, iRecentFiles[1]);
      if (iRecentFilesCount < 3)
        aMenuPane->DeleteMenuItem(EAsmRecentFile3);
      else
        aMenuPane->SetItemTextL(EAsmRecentFile3, iRecentFiles[2]);
      if (iRecentFilesCount < 4)
        aMenuPane->DeleteMenuItem(EAsmRecentFile4);
      else
        aMenuPane->SetItemTextL(EAsmRecentFile4, iRecentFiles[3]);
      if (iRecentFilesCount < 5)
        aMenuPane->DeleteMenuItem(EAsmRecentFile5);
      else
        aMenuPane->SetItemTextL(EAsmRecentFile5, iRecentFiles[4]);
    }
    break;

  case R_ASM_FILE_MENU:
    {
      TBool dim = ETrue;

      dim = EFalse;
      if (iRecentFilesCount == 0)   dim = ETrue;
      aMenuPane->SetItemDimmed(EAsmMenuRecentFiles, dim);
    }
    break;
  }
}


void CAsmAppView::UpdateScrollBar(TInt aYChange, TBool aForce) {

  iScrolled += aYChange;

  TPoint screensize = iCoeEnv->ScreenDevice()->SizeInPixels().AsPoint();

  TInt sspan = iHeight;
  if (sspan < screensize.iY)   sspan = screensize.iY;

  if (sspan == iScrollSpan) {
    if (aYChange || aForce) {
      iThumbPosition = -iScrolled;
      iVBar->SetModelThumbPosition(iThumbPosition);
    }
  } else {
    TEikScrollBarModel model;
    iThumbPosition = -iScrolled;
    iScrollSpan = sspan;
    model.iScrollSpan = iScrollSpan;
    model.iThumbSpan = screensize.iY;
    model.iThumbPosition = iThumbPosition;
    model.CheckBounds();
    iVBar->SetModelL(&model);
  }
}


void CAsmAppView::CreateComponentControlsL() {
  CreateScrollBarL();
}


void CAsmAppView::RemoveScrollBarL() {
  delete iVBar;
}


void CAsmAppView::CreateScrollBarL() {

  TInt length;
  TInt flags = 0;
  TInt posx, posy;

  TPoint screensize = iCoeEnv->ScreenDevice()->SizeInPixels().AsPoint();

  length = screensize.iY;
  posx = screensize.iX - CEikScrollBar::EScrollbarWidth;
  if (iAppUi->iToolBarVisible)   posx -= KEikStdToolBarWidth;
//  else   posx -= KEikStdToolBarWidth-10;
  posy = 0;
//  flags |= CEikScrollBar::EEikScrollBarHasPageButtons;

  TEikScrollBarModel model(iScrollSpan, screensize.iY, iThumbPosition);

  iVBar = new (ELeave) CEikScrollBar;
  iVBar->ConstructL(this, this, CEikScrollBar::EVertical, 0, flags);
  iVBar->SetPosition(TPoint(posx, posy));
  iVBar->SetLengthAndModelL(length, &model);
  iVBar->ActivateL();
}


CAsmAppView::~CAsmAppView() {
  if (iClipboard)   delete iClipboard;
  delete iTextView;
  delete iLayout;
  delete iParaFormatLayer;
  delete iCharFormatLayer;
  delete iGlobalText;
  delete iVBar;
  delete iBitmap;
}


void CAsmAppView::Draw(const TRect& /*aRect*/) const {
// redraw the window

  CWindowGc& gc = SystemGc();

  // draw editable text
  TInt err;
  TRAP(err,iTextView->DrawL(Rect()));
  if (iActivated) {
  }
}


void CAsmAppView::HandlePointerEventL(const TPointerEvent& aPointerEvent) {
// called when the user taps the screen in the application view.

  switch (aPointerEvent.iType) {
  case TPointerEvent::EButtonRepeat:
    break;
  case TPointerEvent::EDrag:
    {
      TPoint clickpos = aPointerEvent.iPosition;
      TInt pos = iTextView->XyPosToDocPosL(clickpos);
      if (pos != iPos) {
        if (iSelectionStart == -1)  iSelectionStart = iPos;
        iPos = pos;
        iSelectionEnd = iPos;
        TPoint scrolling = iTextView->SetDocPosL(iPos, ETrue);
        TInt oldp = iParagraphNo;
        UpdateParagraph();
        if (scrolling.iY || iParagraphNo != oldp)
          UpdateScrollBar(scrolling.iY, EFalse);
      }
    }
    break;
  case TPointerEvent::EMove:
    break;
  case TPointerEvent::EButton1Down:
    {
      TPoint clickpos = aPointerEvent.iPosition;
      iPos = iTextView->XyPosToDocPosL(clickpos);
      iTextView->SetDocPosL(iPos, EFalse);
      if (iSelectionStart != -1)   ClearSelection();
      UpdateParagraph();
    }
    break;
  }
}


TKeyResponse CAsmAppView::OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType) {

  TBool consumed, paragraph, setselection, setpos;
  TInt oldpos;
  TPoint scrolling(0,0);

  if (aType != EEventKey)   return EKeyWasNotConsumed;

  TInt code = aKeyEvent.iCode;
  TInt shiftpressed = aKeyEvent.iModifiers & EModifierShift;
  TInt ctrlpressed = aKeyEvent.iModifiers & EModifierCtrl;

  if (code != EKeyUpArrow && code != EKeyDownArrow)
    iPreferredPosOnLine = -1;

  oldpos = iPos;
  setpos = EFalse;
  consumed = ETrue;
  setselection = EFalse;
  paragraph = EFalse;

  // handle selection
  switch (code) {
  case EKeyHome:
  case EKeyEnd:
    if (iSelectionStart != -1)  ClearSelection();
    break;
  case EKeyTab:
  case EKeyDelete:
  case EKeyBackspace:
  case EKeyEnter:
    if (iSelectionStart != -1)
      scrolling = DeleteSelection();
    break;
  case EKeyUpArrow:
  case EKeyDownArrow:
  case EKeyPageUp:
  case EKeyPageDown:
  case EKeyLeftArrow:
  case EKeyRightArrow:
    if ((iSelectionStart != -1) && !shiftpressed)
      ClearSelection();
    else if (shiftpressed) {
      if (iSelectionStart == -1)  iSelectionStart = iPos;
      setselection = ETrue;
    }
    break;
  default:
    if (code >= ' ' && code <= 255)
      if (iSelectionStart != -1)
        scrolling = DeleteSelection();
    break;
  }

  switch (code) {
  case EKeyMenu:
    return EKeyWasConsumed;
    break;
  case EKeyHelp:
    return EKeyWasNotConsumed;
    break;
  case EKeyHome:
    if (ctrlpressed)
      iPos = 0;
    else
      iPos = iParagraphStartPos;
    setpos = ETrue;
    paragraph = ETrue;
    break;
  case EKeyEnd:
    {
      TInt plen;
      if (aKeyEvent.iModifiers & EModifierCtrl)
        // scroll to first char on last line
        iPos = iGlobalText->CharPosOfParagraph(plen, iParagraphCount-1);
      else {
        // scroll to end of line
        iParagraphStartPos =
              iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
        if (plen <= 0)  plen = 1;
        iPos = iParagraphStartPos + plen - 1;
      }
      setpos = ETrue;
      paragraph = ETrue;
    }
    break;
  case EKeyTab:
    {
      TInt plen;
      TInt pstart = iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      TInt poffset = iPos - pstart;
      TInt insert = ((poffset + 1) & ~1) - poffset;
      if (insert == 0)  insert = 2;

      TBuf<4> c;
      c.Zero();
      for (TInt i = 0; i < insert; i++)   c.Append(' ');
      iGlobalText->InsertL(iPos, c);
      TCursorSelection inserted;
      inserted.SetSelection(iPos, iPos+insert);
      iTextView->HandleInsertDeleteL(inserted, 0);
      iPos += insert;
      setpos = ETrue;

      iHasChanged = 1;
      UpdateErrorPointers(iPos-insert, insert);
    }
    break;
  case EKeyUpArrow:
    if (iParagraphNo > 0) {
      TInt plen;
      TInt pstart = iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      TInt poffset = iPos - pstart; // current pos

      TInt preferred = iPreferredPosOnLine;
      if (preferred == -1) {
        // no saved pos from previous up/downs, so use current pos
        preferred = poffset;
        iPreferredPosOnLine = poffset;
      }

      iParagraphNo--;
      iParagraphStartPos =
            iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      if (plen <= 0)  plen = 1;
      if (preferred > plen-1)    preferred = plen-1;
      iPos = iParagraphStartPos + preferred;
      setpos = ETrue;

      paragraph = ETrue;
    }
    break;
  case EKeyDownArrow:
    if (iParagraphNo < iParagraphCount-1) {
      TInt plen;
      TInt pstart = iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      TInt poffset = iPos - pstart;

      TInt preferred = iPreferredPosOnLine;
      if (preferred == -1) {
        // no saved pos from previous up/downs, so use current pos
        preferred = poffset;
        iPreferredPosOnLine = poffset;
      }

      iParagraphNo++;
      iParagraphStartPos =
           iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      if (plen <= 0)  plen = 1;
      if (preferred > plen-1)    preferred = plen-1;
      iPos = iParagraphStartPos + preferred;
      setpos = ETrue;

      paragraph = ETrue;
    }
    break;
  case EKeyEnter:
    if (shiftpressed) {
      // insert the Enter
      iGlobalText->InsertL(iPos, CEditableText::EParagraphDelimiter);
      // update
      scrolling.iY += iTextView->HandleCharEditL(CTextLayout::EFParagraphDelimiter);
      // set pos
      UpdateErrorPointers(iPos, 1);
      iPos++;
    } else {
      // insert empty line below current
      TInt plen;
      TInt pstart = iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      if (iParagraphNo <= iParagraphCount - 1)  plen--;

      // find how many leading spaces to insert
      TInt leadingspaces = 0;
      TBuf8<16> leadin;
      if (plen > 0) {
        iGlobalText->Extract(leadin, pstart, 16);
        const TUint8 *p;
        p = leadin.Ptr();
        while (*p == ' ' && leadingspaces < 16)  leadingspaces++, p++;
        leadin.SetLength(leadingspaces);
      }

      iPos = pstart + plen;
      scrolling = iTextView->SetDocPosL(iPos, EFalse);
      iGlobalText->InsertL(iPos, CEditableText::EParagraphDelimiter);
      // update
      UpdateErrorPointers(iPos, 1);
      scrolling.iY += iTextView->HandleCharEditL(CTextLayout::EFParagraphDelimiter);
      // set pos
      iPos++;

      if (leadingspaces) {
        // insert leading spaces
        iGlobalText->InsertL(iPos, leadin);
        UpdateErrorPointers(iPos, leadingspaces);
        TCursorSelection inserted;
        inserted.SetSelection(iPos, iPos+leadingspaces);
        iTextView->HandleInsertDeleteL(inserted, 0);
        iPos += leadingspaces;
        iTextView->SetDocPosL(iPos, EFalse);
      }
    }
    iHasChanged = 1;
    paragraph = ETrue;
    break;
  case EKeyPageUp:
    {
      TPoint xy;
      // get coords of textposition
      if (!iTextView->DocPosToXyPosL(iPos, xy)) {
        // if text at textposition isn't formatted, format it ...
        iTextView->FormatTextL();
        // .. and get textposition again
        iTextView->DocPosToXyPosL(iPos, xy);
      }
      // get screen size
      TPoint screensize = iCoeEnv->ScreenDevice()->SizeInPixels().AsPoint();
      // move y position
      xy.iY -= 3*screensize.iY/4;
      if (shiftpressed) {
        TInt pos = iTextView->XyPosToDocPosL(xy);
        scrolling = SetSelection(pos+1);
      } else {
        // get corresponding textposition
        iPos = iTextView->XyPosToDocPosL(xy);
        // set textposition
        setpos = ETrue;
        paragraph = ETrue;
      }
    }
    break;
  case EKeyPageDown:
    {
      TPoint xy;
      // get coords of textposition
      if (!iTextView->DocPosToXyPosL(iPos, xy)) {
        // if text at textposition isn't formatted, format it ...
        iTextView->FormatTextL();
        // .. and get textposition again
        iTextView->DocPosToXyPosL(iPos, xy);
      }
      // get screen size
      TPoint screensize = iCoeEnv->ScreenDevice()->SizeInPixels().AsPoint();
      // move y position
      xy.iY += 3*screensize.iY/4;
      // get corresponding textposition
      if (shiftpressed) {
        TInt pos = iTextView->XyPosToDocPosL(xy);
        scrolling = SetSelection(pos-1);
      } else {
        iPos = iTextView->XyPosToDocPosL(xy);
        // set textposition
        setpos = ETrue;
        paragraph = ETrue;
      }
    }
    break;
  case EKeyLeftArrow:
    if (iPos > 0) {
      if (iPos == iParagraphStartPos)   paragraph = ETrue;
      iPos--;
      setpos = ETrue;
    }
    break;
  case EKeyRightArrow:
    if (iPos < iGlobalText->DocumentLength()) {
      TInt plen;
      iGlobalText->CharPosOfParagraph(plen, iParagraphNo);
      if (iPos >= iParagraphStartPos + plen)  paragraph = ETrue;
      iPos++;
      setpos = ETrue;
    }
    break;
  case EKeyDelete:
  case EKeyBackspace:
    if (iPos > 0) {
      iGlobalText->DeleteL(iPos-1, 1);
      UpdateErrorPointers(iPos, -1);
      if (iPos == iParagraphStartPos)  paragraph = ETrue;
      scrolling.iY += iTextView->HandleCharEditL(CTextLayout::EFLeftDelete);
      iPos--;

      iHasChanged = 1;
    }
    break;
  default:
    if (code >= ' ' && code <= 255) {
      TBuf<1> c;
      c.Zero();
      c.Append(code);
      iGlobalText->InsertL(iPos, c);
      UpdateErrorPointers(iPos, 1);
      iTextView->HandleCharEditL(CTextLayout::EFCharacterInsert);
      iPos++;
      iHasChanged = 1;
    } else
      consumed = EFalse;
    break;
  }

  if (setpos) {
    if (setselection) {
      scrolling = iTextView->SetDocPosL(iPos, ETrue);
      if (iSelectionStart == -1)  iSelectionStart = oldpos;
      iSelectionEnd = iPos;
    } else
      scrolling = iTextView->SetDocPosL(iPos, EFalse);

  } else if (setselection)
    SetSelection(iPos);
  if (paragraph)      UpdateParagraph();
  if ((scrolling.iY) || (paragraph))
    UpdateScrollBar(scrolling.iY, EFalse);

  if (consumed)   return EKeyWasConsumed;
  return EKeyWasNotConsumed;
}


void CAsmAppView::UpdateErrorPointers(TInt aPos, TInt aInserted) {
  TInt i, len;

  len = iGlobalText->DocumentLength()-1;
  for (i = 0; i < iAsmErrorCount; i++) {
    if (iAsmErrorPos[i] > aPos) {
      iAsmErrorPos[i] += aInserted;
      if (iAsmErrorPos[i] < 0)    iAsmErrorPos[i] = 0;
      if (iAsmErrorPos[i] > len)  iAsmErrorPos[i] = len-1;
    }
  }
}


void CAsmAppView::GotoLineNo(TInt aLineNo) {
  TInt plen;
  if (aLineNo >= iParagraphCount)   return;
  if (aLineNo < 0)                  return;
  iPos = iGlobalText->CharPosOfParagraph(plen, aLineNo);

  TPoint scrolling = iTextView->SetDocPosL(iPos, EFalse);
  UpdateParagraph();
  UpdateScrollBar(scrolling.iY, EFalse);
}


TPoint CAsmAppView::SetSelection(TInt pos) {
  TPoint scrolled(0, 0);

  if (iSelectionStart == -1)   iSelectionStart = iPos;

  if (pos < 0)
    pos = 0;
  if (pos > iGlobalText->DocumentLength())
    pos = iGlobalText->DocumentLength();

  if (pos == iSelectionStart) {
    iSelectionStart = -1;
    return scrolled;
  }
  iSelectionEnd = pos;

  TCursorSelection sel(iSelectionEnd, iSelectionStart);
  scrolled = iTextView->SetSelectionL(sel);

  return scrolled;
}


void CAsmAppView::Paste() {
  // first, clear the selection
  if (iSelectionStart != -1)  ClearSelection();
  // make sure there really is something to paste
  if (!iClipboard)            return;
  if (iClipboardSize == 0)    return;
  // insert the text
  iGlobalText->InsertL(iPos, iClipboard->Des());
  UpdateErrorPointers(iPos, iClipboardSize);
  // handle block insert
  TCursorSelection inserted;
  inserted.SetSelection(iPos, iPos+iClipboardSize);
  iTextView->HandleInsertDeleteL(inserted, 0);
  // update pos
  iPos += iClipboardSize;
  TPoint scrolling = iTextView->SetDocPosL(iPos, EFalse);
  // update paragraph info and scrollbar
  UpdateParagraph();
  if (scrolling.iY)  UpdateScrollBar(scrolling.iY, EFalse);
}


void CAsmAppView::Copy() {

  TInt from, len;
  if (iSelectionStart < iSelectionEnd) {
    from = iSelectionStart;
    len = iSelectionEnd - iSelectionStart;
  } else {
    from = iSelectionEnd;
    len = iSelectionStart - iSelectionEnd;
  }

  if (iClipboard)  delete iClipboard;
  iClipboard = NULL;
  if (len == 0)   return;

  iClipboard = HBufC::New(len+1);
  if (!iClipboard)   return;
  TBuf8<128> tmp;
  TInt remaining = len;
  while (remaining) {
    TInt thistime;
    thistime = remaining;
    if (thistime > 128)   thistime = 128;
    iGlobalText->Extract(tmp, from, thistime);
    iClipboard->Des().Append(tmp);
    remaining -= thistime;
    from += thistime;
  }
  iClipboardSize = len;
}


void CAsmAppView::Cut() {

  if (iSelectionStart == -1)   return;
  Copy();
  TPoint scrolled = DeleteSelection();
  UpdateScrollBar(scrolled.iY, EFalse);
}


TPoint CAsmAppView::DeleteSelection() {
// handles (almost) everything to do with deleting selection
// returns the scroll amount (for scrollbar updating)
  TPoint scrolled(0, 0);
  TInt from, chars;

  if (iSelectionStart == -1 || iSelectionEnd == -1)
    return scrolled;

  if (iSelectionEnd < iSelectionStart) {
    chars = iSelectionStart - iSelectionEnd;
    from = iSelectionEnd;
  } else {
    chars = iSelectionEnd - iSelectionStart;
    from = iSelectionStart;
  }
  TCursorSelection sel(from, from);

  ClearSelection();

  iGlobalText->DeleteL(from, chars);
  UpdateErrorPointers(from, -chars);
  scrolled = iTextView->HandleInsertDeleteL(sel, chars, ETrue);
  iPos = from;
  TPoint scrolled2 = iTextView->SetDocPosL(iPos, EFalse);
  UpdateParagraph();
  iHasChanged = 1;

  scrolled.iY += scrolled2.iY;
  return scrolled;
}


void CAsmAppView::ClearSelection() {
  iTextView->CancelSelectionL();
  iSelectionStart = -1;
}


void CAsmAppView::UpdateParagraph() {
// read all the needed info abou the current paragraph/line
  TInt pos, oldpc;
  pos = iPos;
  oldpc = iParagraphCount;
  iParagraphNo = iGlobalText->ParagraphNumberForPos(pos);
  iParagraphStartPos = pos;
  iParagraphCount = iGlobalText->ParagraphCount();
  iHeight = iLayout->FormattedHeightInPixels();
}

// ------------------------------------------------------------

TBool CAsmAppView::DoSaveFile() {
  return DoSaveFileAs(iFileName);
}


TBool CAsmAppView::DoSaveFileAs(const TFileName& aFileName) {

  if (!iHasChanged)                     return EFalse; // no error
  if (aFileName.Size() == 0)            return EFalse;

  // make sure the name ends in a .s
  TFileName saveas = aFileName;
  TParse parseleaf;
  TBool report_ext = EFalse;

  parseleaf.Set(saveas, NULL, NULL);
  if (parseleaf.ExtPresent()) {
    TPtrC ext = parseleaf.Ext();
    if (ext.CompareF(_L(".S"))) {
      TFileName temp;
      temp.Format(_L("%S%S.s"), &parseleaf.DriveAndPath(), &parseleaf.Name());
      saveas = temp;
      report_ext = ETrue;
    }
  } else {
    saveas.Append(_L(".s"));
    report_ext = ETrue;
  }
  // report something to the user
  if (report_ext)
    iEikonEnv->InfoMsg(KInfoSAppended);
  else
    iEikonEnv->InfoMsg(KInfoSavingFile);

  iGlobalText->ExportAsTextL(saveas, CPlainText::EOrganiseByParagraph, 0);

  iHasChanged = 0;
  iFileName = saveas;
  AddToListOfRecentFiles(iFileName);

  return EFalse;
}


TBool CAsmAppView::DoCreateNewFile(const TFileName& aFileName) {

  if (iHasChanged)    DoSaveFile();

  // make sure the name ends in a .s
  TFileName newfile = aFileName;
  TParse parseleaf;
  TBool report_ext = EFalse;

  parseleaf.Set(newfile, NULL, NULL);
  if (parseleaf.ExtPresent()) {
    TPtrC ext = parseleaf.Ext();
    if (ext.CompareF(_L(".S"))) {
      TFileName temp;
      temp.Format(_L("%S%S.s"), &parseleaf.DriveAndPath(), &parseleaf.Name());
      newfile = temp;
      report_ext = ETrue;
    }
  } else {
    newfile.Append(_L(".s"));
    report_ext = ETrue;
  }

  // reset globaltext
  iGlobalText->Reset();
  //set up everything
  iPreferredPosOnLine = -1;
  iPos = 0;
  iHasChanged = 0;
  iAsmErrorCount = 0;
  iScrolled = iHeight = iScrollSpan = iThumbPosition = 0;
  iSelectionStart = iSelectionEnd = -1;
  UpdateParagraph();
  iTextView->SetDocPosL(iPos, EFalse);
  TInt err;
  TRAP(err,iTextView->FormatTextL());

  UpdateScrollBar(0, ETrue);

  iFileName = newfile;
  AddToListOfRecentFiles(iFileName);

  return EFalse;
}


TBool CAsmAppView::DoOpenFile(const TFileName& aFileName) {

  RFs fs;
  RFile file;
  TBuf8<4> buffer;
  TInt x, y;
  // tell the user
  iEikonEnv->InfoMsg(KInfoOpeningFile);
  // open file
  fs.Connect();
  if (file.Open(fs, aFileName, EFileShareExclusive)) {
    fs.Close();
    return ETrue;
  }
  // reset global text
  iGlobalText->Reset();
  iPos = 0;
  // prepare for text-file reading
  TFileText ft;
  ft.Set(file);
  // read text file
  TBool more = ETrue;
  TBuf8<256> line;
  while (more) {
    TInt errorcode = ft.Read(line);
    if (errorcode == KErrEof)
      more = EFalse;
    else {
      iGlobalText->InsertL(iPos, line);
      iPos += line.Length();
      iGlobalText->InsertL(iPos, CEditableText::EParagraphDelimiter);
      iPos++;
    }
  }
  // close file
  file.Close();
  fs.Close();
  // set up everything
  TInt err;
  TRAP(err,iTextView->FormatTextL());

  iPreferredPosOnLine = -1;
  iPos = 0;
  iTextView->SetDocPosL(iPos, EFalse);

  iHasChanged = 0;
  iAsmErrorCount = 0;
  iScrolled = iHeight = iScrollSpan = iThumbPosition = 0;
  iSelectionStart = iSelectionEnd = -1;
  UpdateParagraph();
  UpdateScrollBar(0, ETrue);

  iFileName = aFileName;
  AddToListOfRecentFiles(aFileName);

  iIncludeFile = _L("");
  return EFalse;
}


TBool CAsmAppView::DoSaveFileAssembled(const TFileName& aFileName) {

  RFs fs;
  RFile file;
  // make sure the filename is legal
  if (aFileName.Size() == 0)            return EFalse;
  iEikonEnv->InfoMsg(KInfoSavingFile);
  // open file
  fs.Connect();
  if (file.Replace(fs, aFileName, EFileShareExclusive)) {
    fs.Close();
    return ETrue;
  }
  // write the data
  TPtrC8 buf;
  buf.Set((TUint8 *)iAssembledOutput, iAssembledSize);
  file.Write(buf, iAssembledSize);
  // close file
  file.Close();
  fs.Close();
  iSavedAsmFileName = aFileName;

  return EFalse;
}

// ------------------------------------------------------------

void CAsmAppView::Assemble() {

  if (iFileName.Compare(_L("")) == 0) {
    iEikonEnv->InfoWinL(KInfoAssembling, KInfoSaveFirst);
    return;
  }
  if (iHasChanged)    DoSaveFile();

  iEikonEnv->BusyMsgL(KInfoAssembling);

  if (iAssembledOutput) User::Free(iAssembledOutput);
  iAssembledOutput = NULL;

  TFileName filename = iFileName;

  PREPROCESS *pre;
  ASM *assm;
  ASMERROR *asmerrors;
  LINE *lines;
  char **filenames;
  char errmsg[256];
  int filenamecount, linecount;

  pre = preprocessor("", (char *)iLibrary.PtrZ(), (char *)filename.PtrZ(), errmsg);
  if (!pre) {
    TPtrC8 buf;
    buf.Set((TUint8 *)errmsg, strlen(errmsg));
    iEikonEnv->BusyMsgCancel();
    iEikonEnv->InfoWinL(KInfoAsmDoneErr, buf);
    return;
  }
  preprocessor_info(pre, &lines, &linecount, &filenames, &filenamecount);

  // do it...
  assm = assembler(lines, linecount, NULL);
  if (!assm) {
    preprocessor_kill(pre);
    iEikonEnv->BusyMsgCancel();
    iEikonEnv->InfoWinL(KInfoAsmDoneErr, KInfoAsmFailed);
    return;
  }

  iEikonEnv->BusyMsgCancel();

  // get info about generated code and exported/imported symbols
  U32 errorcount = assembler_errors(assm, &asmerrors);
  if (errorcount == 0) {
    U32 size;
    void *ptr;
    assembler_output(assm, &size, &ptr);
    iAssembledSize = size;
    iAssembledOutput = User::Alloc(size);
    if (!iAssembledOutput) {
      preprocessor_kill(pre);
      assembler_kill(assm);
      iEikonEnv->InfoWinL(KInfoAsmDoneErr, KInfoAsmFailed);
      return;
    }
    Mem::Copy(iAssembledOutput, ptr, size);
    TBuf8<256> ok;
    ok.Format(KInfoAsmComplete, iAssembledSize);
    iEikonEnv->InfoWinL(KInfoAsmDoneOK, ok);

  } else {
    TBuf8<256> report;
    ASMERROR *err1;

    err1 = asmerrors+0;
    report.Format(KInfoAsmDoneErrInfo, errorcount,
                                       filenames[err1->fileno],
                                       err1->lineno,
                                       err1->errmsg);

    TPtrC8 efilename;
    efilename.Set((TUint8 *)filenames[err1->fileno],
                    strlen(filenames[err1->fileno]));
    if (efilename.Compare(filename) == 0)  GotoLineNo(err1->lineno-1);

    iEikonEnv->InfoWinL(KInfoAsmDoneErr, report);
    iAsmErrorCount = 0;
    for (TInt i = 0; (i < errorcount) && (iAsmErrorCount < 20); i++) {
      TInt lineno;

      lineno = asmerrors[i].lineno - 1;
      if ((asmerrors[i].fileno == 0) && (lineno >= 0) && (lineno < iParagraphCount)) {
        TInt plen;
        iAsmErrorPos[i] = iGlobalText->CharPosOfParagraph(plen, lineno);
        iAsmErrors[i].Format(_L("%s"), asmerrors[i].errmsg);
        iAsmErrorCount++;
      }
    }
  }

  preprocessor_kill(pre);
  assembler_kill(assm);
}

void CAsmAppView::OpenRecentFile(TInt iWhich) {
  if (iWhich >= iRecentFilesCount)  return;
  DoSaveFile();
  DoOpenFile(iRecentFiles[iWhich]);
  DrawNow();
}


void CAsmAppView::RemoveFromListOfRecentFiles(const TFileName& aFileName) {
}


void CAsmAppView::AddToListOfRecentFiles(const TFileName& aFileName) {

  TParse parse;

  parse.Set(aFileName, NULL, NULL);
  TFileName add = parse.FullName();

  for (TInt i = 0; i < iRecentFilesCount; i++)
    if (iRecentFiles[i].CompareF(add) == 0) {
      if (i == 0)   return;
      iRecentFiles[i] = iRecentFiles[0];
      iRecentFiles[0] = add;
      return;
    }

  if (iRecentFilesCount == 5) {
    iRecentFiles[4] = iRecentFiles[3];
    iRecentFiles[3] = iRecentFiles[2];
    iRecentFiles[2] = iRecentFiles[1];
    iRecentFiles[1] = iRecentFiles[0];
    iRecentFiles[0] = add;
  } else {
    iRecentFiles[iRecentFilesCount++] = add;
  }
}

void CAsmAppView::InfoWindow(const TDesC& aTitle, const TDesC& aText) {
  iEikonEnv->InfoWinL(aTitle, aText);
}

void CAsmAppView::GotoError(TInt aDirection) {
  if (iAsmErrorCount == 0)   return;

  TInt err = -1;
  TInt closest = 100000000;

  if (aDirection > 0) {
    for (TInt i = 0; i < iAsmErrorCount; i++) {
      TInt dist;
      dist = iAsmErrorPos[i] - iPos;
      if ((dist > 0) && (dist < closest)) {
        closest = dist;
        err = i;
      }
    }
  } else {
    for (TInt i = 0; i < iAsmErrorCount; i++) {
      TInt dist;
      dist = iPos - iAsmErrorPos[i];
      if ((dist > 0) && (dist < closest)) {
        closest = dist;
        err = i;
      }
    }
  }
  if (err == -1) {
    if (aDirection > 0) {
      err = 0;
      for (TInt i = 1; i < iAsmErrorCount; i++)
        if (iAsmErrorPos[i] < iAsmErrorPos[err])   err = i;
    } else {
      err = iAsmErrorCount-1;
      for (TInt i = 0; i < iAsmErrorCount-1; i++)
        if (iAsmErrorPos[i] < iAsmErrorPos[err])   err = i;
    }
  }

  TInt lineno = iGlobalText->ParagraphNumberForPos(iAsmErrorPos[err]);
  GotoLineNo(lineno);
  iEikonEnv->InfoMsg(iAsmErrors[err]);
}
