

#define MAXMACROS             256
#define MAXFILES              128
#define MAXLINELENGTH         1024

typedef struct LINE LINE;
typedef struct PREPROCESS PREPROCESS;
typedef struct MACRO MACRO;


struct LINE {
  char *line;
  unsigned int lineno;
  unsigned short fileno; // the filename passed to preprocessor() will always be #0
};


struct MACRO {
  char *name, *value;
};



#ifdef __cplusplus
extern "C" {
#endif
PREPROCESS *preprocessor(char *dir, char *libdir, char *filename, char *errmsg);
void preprocessor_info(PREPROCESS *p, LINE **l, int *lc, char ***f, int *fc);
void preprocessor_kill(PREPROCESS *p);
#ifdef __cplusplus
}
#endif
